;********************************************************************
;    Filename:	     V1.asm                
;    Date:           26/10/2012            
;    File Version:   12102600                 
;    Author(s):                
;    Company:        VSER                    
;********************************************************************
;    Files required: text.h, options.h, header.h, constants.h
;		     variables.h, macro.h 
;                    V1.asm, reset.asm, isrh.asm,isrl.asm
;                    init.asm, subroutines.asm		
;		     eeprom.asm
;********************************************************************
;    Notes:             
;    - processor:    PIC18F4520         
;    - quartz:       18.4320 MHz          
;********************************************************************
		#INCLUDE	<text.h>
		#INCLUDE	<options.h>
		#INCLUDE	<header.h>
		#INCLUDE	<constants.h>
		#INCLUDE	<variables.h>
		#INCLUDE	<macro.h>
;********************************************************************
;CODE
		ORG	StartUserCode
		#INCLUDE	<reset.asm>		;
;
		ORG	StartUserCode+0x0008
		goto	InterruptHigh			;
;
		ORG	StartUserCode+0x0018
		goto	InterruptLow			;
;***********************************************************************
		ORG	StartUserCode+0x002A
Main		
;osmobitna petlja
		movlw	low	(c_08-c_loop_count08)
		movwf	loop_counter0
		clrf	(buffer0+0)
		clrf	(buffer0+1)
		clrf	(buffer0+2)
;
main_loop08	
		movlw	low	c_korak			
		addwf	(buffer0+0)
		movlw	high	c_korak
		addwfc	(buffer0+1)	
		movlw	upper	c_korak
		addwfc	(buffer0+2)	
;
		incfsz	loop_counter0
		bra	main_loop08
		nop
;main_loop08_end	
;
;sestnaestobitna petlja
		movlw	low	(c_16-c_loop_count16)
		movwf	loop_counter0
		movlw	high	(c_16-c_loop_count16)
		movwf	loop_counter1
		clrf	(buffer0+0)
		clrf	(buffer0+1)
		clrf	(buffer0+2)
;
main_loop16	
		movlw	low	c_korak			
		addwf	(buffer0+0)
		movlw	high	c_korak
		addwfc	(buffer0+1)	
		movlw	upper	c_korak
		addwfc	(buffer0+2)	
;
		infsnz	loop_counter0
		incfsz	loop_counter1		
		bra	main_loop16
		nop
;main_loop16_end	
;
;dvadesetcetvorobitna petlja
		movlw	low	(c_24-c_loop_count24)
		movwf	loop_counter0
		movlw	high	(c_24-c_loop_count24)
		movwf	loop_counter1
		movlw	upper	(c_24-c_loop_count24)
		movwf	loop_counter2
		clrf	(buffer0+0)
		clrf	(buffer0+1)
		clrf	(buffer0+2)
;
main_loop24	
		movlw	low	c_korak			
		addwf	(buffer0+0)
		movlw	high	c_korak
		addwfc	(buffer0+1)	
		movlw	upper	c_korak
		addwfc	(buffer0+2)	
;
		incf	loop_counter0
		bnz	$+4
		incf	loop_counter1		
		bnz	$+4
		incf	loop_counter2		
		bnz	main_loop24
		nop
;main_loop24_end	
;
		rcall	TestLine0
		rcall	TestLine1
;		
dead_loop
		clrwdt
		bra	dead_loop
;
;MainEnd
;***********************************************************************
		#INCLUDE	<isrh.asm>		;
		#INCLUDE	<isrl.asm>		;
		#INCLUDE	<init.asm>		;
		#INCLUDE	<subroutines.asm>	;
;
EndOfCode	;0x7DC0 - 0x7DFF reserved for ICD2
	IF	EndOfCode > 0x7DC0
		error" Error out of range in EndOfCode "
	ENDIF
;
		ORG	0xF00000	
		#INCLUDE	<eeprom.asm>		;
;********************************************************************
		END
;
