;
;********************************************************************
;    Filename:	     V2.asm                
;    Date:           02/11/2012            
;    File Version:   12110200                 
;    Author(s):                
;    Company:        VSER                    
;********************************************************************
;    Files required: text.h, options.h, header.h, constants.h
;		     variables.h, macro.h 
;                    V2.asm, reset.asm, isrh.asm,isrl.asm
;                    init.asm, subroutines.asm		
;		     eeprom.asm
;********************************************************************
;    Notes:             
;    - processor:    PIC18F4520         
;    - quartz:       18.4320 MHz          
;********************************************************************
		#INCLUDE	<text.h>
		#INCLUDE	<options.h>
		#INCLUDE	<header.h>
		#INCLUDE	<constants.h>
		#INCLUDE	<variables.h>
		#INCLUDE	<macro.h>
;********************************************************************
;CODE
		ORG	StartUserCode
		#INCLUDE	<reset.asm>		;
;
		ORG	StartUserCode+0x0008
		goto	InterruptHigh			;
;
		ORG	StartUserCode+0x0018
		goto	InterruptLow			;
;
;***********************************************************************
;
		ORG	StartUserCode+0x002A
Main		
		lfsr	FSR0,buffer		;Inicijalizovati, u glavnom programu, FSR0 sa adresom buffer.
		movlw	c_buffer_length		;Inicijalizovati loop_counter
		movwf	loop_counter		;	sa vrednoscu c_buffer_length.
		clrf	WREG			;Obrisati WREG.
main_loop0	
		movwf	POSTINC0		;Primenom programske petlje upisati u buffer sadrzaj WREG.
		addlw	c_korak			;U svakom prolazu kroz petlju povecavati sadrzaj WREG za c_korak.
		decfsz	loop_counter		;Broj prolaza brojati loop_counter-om.
		bra	main_loop0		;
;
		movlw	0xAA			;U file registar na adresi buffer_end
		movff	WREG,buffer_end		;	upisati 0xAA.
;		
		lfsr	FSR0,buffer		;Inicijalizovati FSR0 sa adresom buffer.
main_loop1	
		clrf	POSTINC0		;Primenom programske petlje obrisati buffer.
		movlw	high	buffer_end	;Za izlazak iz petlje koristiti
		cpfseq	FSR0H 			;poredjenje FSR0 sa buffer_end.
		bra	main_loop1		;
		movlw	low	buffer_end	;
		cpfseq	FSR0L 			;
		bra	main_loop1		;
;
		movlw	0x55			;U file registar na adresi buffer_end
		movff	WREG,buffer_end		;	upisati 0x55.
;		
dead_loop	
		clrwdt				;Zaglaviti se u mrtvoj petlji
		bra	dead_loop		;
;MainEnd
;
;***********************************************************************
;
		#INCLUDE	<isrh.asm>		;
		#INCLUDE	<isrl.asm>		;
		#INCLUDE	<init.asm>		;
		#INCLUDE	<subroutines.asm>	;
;
EndOfCode	;0x7DC0 - 0x7DFF reserved for ICD2
	IF	EndOfCode > 0x7DC0
	 error" Error out of range in EndOfCode "
	ENDIF
;
		ORG	0xF00000	
		#INCLUDE	<eeprom.asm>		;
;
;********************************************************************
;
		END
;
;
