;
;********************************************************************
;    Filename:	     V3.asm                
;    Date:           09/11/2012            
;    File Version:   12110900                 
;    Author(s):                
;    Company:        VSERss                    
;********************************************************************
;    Files required: text.h, options.h, header.h, constants.h
;		     variables.h, macro.h 
;                    V3.asm, reset.asm, isrh.asm,isrl.asm
;                    init.asm, subroutines.asm		
;		     eeprom.asm
;********************************************************************
;    Notes:             
;    - processor:    PIC18F4520         
;    - quartz:       18.432000 MHz          
;********************************************************************
		#INCLUDE	<text.h>
		#INCLUDE	<options.h>
		#INCLUDE	<header.h>
		#INCLUDE	<constants.h>
		#INCLUDE	<macro.h>
;********************************************************************
;CODE
		ORG	StartUserCode
		#INCLUDE	<reset.asm>		;
;
		ORG	StartUserCode+0x0008
		goto	InterruptHigh			;
;
		ORG	StartUserCode+0x0018
		goto	InterruptLow			;
;
;***********************************************************************
;
		ORG	StartUserCode+0x002A
;
Main		
		lfsr	FSR0,buffer
;
		movlw	low	((TableEnd-Table)/2)
		movwf	table_counter
;
		movlw	upper	(Table-2)
		movwf	PCLATU
		movlw	high	(Table-2)
		movwf	PCLATH
		movlw	low	(Table-2)
		movwf	table_pointer
;
main_loop0	
		call	ReadTable
		xorlw	'e'
		bz	main_loop_no_copy
		xorlw	'e' ^ 'a'
		bz	main_loop_no_copy
		xorlw	'a'
		iorlw	B'00001001'
		andlw	B'11101011'
		xorlw	B'01100010'
		movwf	POSTINC0
main_loop_no_copy		
		decfsz	table_counter
		bra	main_loop0
;		
main_dead_loop
		clrwdt
		bra	main_dead_loop
;
;MainEnd
;
;***********************************************************************
;
		#INCLUDE	<isrh.asm>		;
		#INCLUDE	<isrl.asm>		;
		#INCLUDE	<init.asm>		;
		#INCLUDE	<subroutines.asm>	;
		#INCLUDE	<variables.h>		;
;
EndOfCode	;0x7DC0 - 0x7DFF reserved for ICD2
	IF	EndOfCode > 0x7DC0
	 error" Error out of range in EndOfCode "
	ENDIF
;
		ORG	0xF00000	
		#INCLUDE	<eeprom.asm>		;
;
;********************************************************************
;
		END
;
;
