;
;********************************************************************
;    Filename:	     V4.asm                
;    Date:           16/11/2012            
;    File Version:   12111600                 
;    Author(s):                
;    Company:        VSERss                    
;********************************************************************
;    Files required: text.h, options.h, header.h, constants.h
;		     variables.h, macro.h 
;                    V4.asm, reset.asm, isrh.asm,isrl.asm
;                    init.asm, subroutines.asm		
;		     eeprom.asm
;********************************************************************
;    Notes:             
;    - processor:    PIC18F4520         
;    - quartz:       18.432000 MHz          
;********************************************************************
		#INCLUDE	<text.h>
		#INCLUDE	<options.h>
		#INCLUDE	<header.h>
		#INCLUDE	<constants.h>
		#INCLUDE	<variables.h>
		#INCLUDE	<macro.h>
;********************************************************************
;CODE
		ORG	StartUserCode
		#INCLUDE	<reset.asm>		;
;
		ORG	StartUserCode+0x0008
		goto	InterruptHigh			;
;
		ORG	StartUserCode+0x0018
		goto	InterruptLow			;
;
;***********************************************************************
;
		ORG	StartUserCode+0x002A
;
Main
main_wait4taster
		clrwdt
		btfss	Taster
		bra	main_wait4taster
;inicijalizacija bafera
		movlw	(buffer_end-buffer)
		movwf	loop_counter0
		lfsr	FSR0,buffer
		movlw	c_fill_chr
main_loop0	
		movwf	POSTINC0
		decfsz	loop_counter0
		bra	main_loop0	
;
;inicijalizacija generatora slucajnih brojeva
		movf	TMR0L,W
		movwf	rnd0
		clrf	rnd1
;
;izvlacenje
		movlw	(buffer_end-buffer)
		movwf	loop_counter0
		lfsr	FSR0,buffer
main_loop1
		rcall	Rnd16
		movff	rnd0,temp00
		movff	rnd1,temp01
		rrcf	temp01
		rrcf	temp00
		rrcf	temp00
		rrcf	temp00,W
		andlw	c_mask0				;maskiranje b7 i b6
		movwf	temp00
		movlw	c_min-1				;da li je veci ili jednak c_min
		cpfsgt	temp00
		bra	main_loop1			
		movlw	c_max+1				;da li je manji ili jednak c_max
		cpfslt	temp00
		bra	main_loop1
;
;provera da li je vec izvucen
		movlw	(buffer_end-buffer)
		movwf	loop_counter1
		lfsr	FSR1,buffer
		movf	temp00,W	
;
main_loop2		
		cpfseq	POSTINC1
		bra	main_non_equ
		bra	main_loop1			;vec je izvucen
main_non_equ
		decfsz	loop_counter1
		bra	main_loop2
;
		movwf	POSTINC0			;novi broj se upisuje u bafer
		decfsz	loop_counter0
		bra	main_loop1						
;
main_dead_loop	
		clrwdt
		bra	main_dead_loop
;MainEnd
;
;***********************************************************************
;
		#INCLUDE	<isrh.asm>		;
		#INCLUDE	<isrl.asm>		;
		#INCLUDE	<init.asm>		;
		#INCLUDE	<subroutines.asm>	;
;
EndOfCode	;0x7DC0 - 0x7DFF reserved for ICD2
	IF	EndOfCode > 0x7DC0
	 error" Error out of range in EndOfCode "
	ENDIF
;
		ORG	0xF00000	
		#INCLUDE	<eeprom.asm>		;
;
;********************************************************************
;
		END
;
;
