;
;********************************************************************
;    Filename:	     V6.asm                
;    Date:           30/11/2012            
;    File Version:   12113000                 
;    Author(s):                
;    Company:        VSERss                    
;********************************************************************
;    Files required: text.h, options.h, header.h, constants.h
;		     variables.h, macro.h 
;                    V6.asm, reset.asm, isrh.asm,isrl.asm
;                    init.asm, subroutines.asm		
;		     eeprom.asm
;********************************************************************
;    Notes:             
;    - processor:    PIC18F4520         
;    - quartz:       18.432000 MHz          
;********************************************************************
		#INCLUDE	<text.h>
		#INCLUDE	<options.h>
		#INCLUDE	<header.h>
		#INCLUDE	<constants.h>
		#INCLUDE	<variables.h>
		#INCLUDE	<macro.h>
;********************************************************************
;CODE
		ORG	StartUserCode
		#INCLUDE	<reset.asm>		;
;
		ORG	StartUserCode+0x0008
		goto	InterruptHigh			;
;
		ORG	StartUserCode+0x0018
		goto	InterruptLow			;
;
;***********************************************************************
;
		ORG	StartUserCode+0x002A
;
Main
;************************ Vezba4a **************************************
main_wait4taster
		clrwdt
		btfss	Taster
		bra	main_wait4taster
;
;inicijalizacija generatora slucajnih brojeva
		movf	TMR0L,W
		movwf	rnd0
		clrf	rnd1
;
;izvlacenje
		movlw	(buffer0_end-buffer0)
		movwf	loop_counter0
		lfsr	FSR0,buffer0
main_loop1
		rcall	Rnd16
		movff	rnd0,temp00
		movff	rnd1,temp01
		rrcf	temp01
		rrcf	temp00
		rrcf	temp00
		rrcf	temp00,W
		andlw	c_mask0				;maskiranje b7 i b6
		movwf	temp00
		movlw	c_min-1				;da li je veci ili jednak c_min
		cpfsgt	temp00
		bra	main_loop1			
		movlw	c_max+1				;da li je manji ili jednak c_max
		cpfslt	temp00
		bra	main_loop1
;
;provera da li je vec izvucen
		movlw	(buffer0_end-buffer0)
		movwf	loop_counter1
		movf	loop_counter0,W
		subwf	loop_counter1			;koliko je brojeva upisano u buffer0 
		lfsr	FSR1,buffer0
		movf	temp00,W			;vracamo izvuceni broj u W 
;
		movf	loop_counter1
		bz	main_loop2_out
;
main_loop2
		cpfseq	POSTINC1
		bra	main_non_equ
		bra	main_loop1			;vec je izvucen
main_non_equ
		decfsz	loop_counter1
		bra	main_loop2
;
main_loop2_out		
		movwf	POSTINC0			;upisujemo izvuceni broj u buffer0
		decfsz	loop_counter0
		bra	main_loop1						
;
;****************************** Vezba 5 ********************************
;konverzija iz HEX u BCD format
		movlw	(buffer0_end-buffer0)
		movwf	loop_counter0
		lfsr	FSR0,buffer0
		lfsr	FSR1,buffer1
;
main_loop3		
		rcall	Hex2Bcd
		decfsz	loop_counter0
		bra	main_loop3
;
;konverzija BCD u 7 segment LED displej format
		movlw	(buffer1_end-buffer1)
		movwf	loop_counter0
		lfsr	FSR0,buffer1
		lfsr	FSR1,buffer2
;
main_loop4		
		movlw	upper	Table			;inicijalizacija TBLPTR
		movwf	TBLPTRU
		movlw	high	Table
		movwf	TBLPTRH
		movlw	low	Table
		movwf	TBLPTRL
;
		movf	POSTINC0,W			;dodavanje ofseta
		addwf	TBLPTRL
		movlw	0
		addwfc	TBLPTRH				
		movlw	0
		addwfc	TBLPTRU
		tblrd*					;citanje podataka iz tabele
		movff	TABLAT,POSTINC1
		decfsz	loop_counter0
		bra	main_loop4
;						
;serijsko slanje podataka
		movlw	(buffer2_end-buffer2)
		movwf	loop_counter0
		lfsr	FSR0,(buffer2_end-1)
		bcf	Clk
		movlw	2+1
		movwf	loop_counter1
;
main_loop5
		decfsz	loop_counter1
		bra	main_loop5_do
		movlw	2+1
		movwf	loop_counter1
		bra	main_loop5_out
main_loop5_do
		movlw	8
		movwf	loop_counter2
main_loop6
		rrcf	INDF0
		bsf	TxD				;postavi podatak
		btfss	STATUS,C	
		bcf	TxD
;
		nop					;upisi podatak
		bsf	Clk				
		nop
		bcf	Clk
;
		decfsz	loop_counter2
		bra	main_loop6
;
		rrcf	INDF0				;podatak neizmenjen
main_loop5_out
		movf	POSTDEC0			;dekrementiraj FSR0
;
		decfsz	loop_counter0
		bra	main_loop5
;
;****************************** Vezba 6 ******************************************************
;
;sortiranje
                rcall   Sort0
;
                rcall   Sort1
                rcall   Sort0
;konverzija Hex2Asc
                movlw   (buffer0_end-buffer0)
                movwf   loop_counter0
                lfsr    FSR0,buffer0
                lfsr    FSR1,buffer3
main_loop7
                swapf   INDF0,W
                rcall   Hex2Ascii
                movwf   POSTINC1
                movf    POSTINC0,W
                rcall   Hex2Ascii
                movwf   POSTINC1
                decfsz  loop_counter0
                bra     main_loop7
;
main_dead_loop	
		clrwdt
		bra	main_dead_loop
;MainEnd
;***********************************************************************
;
		#INCLUDE	<isrh.asm>		;
		#INCLUDE	<isrl.asm>		;
		#INCLUDE	<init.asm>		;
		#INCLUDE	<subroutines.asm>	;
;
EndOfCode	;0x7DC0 - 0x7DFF reserved for ICD2
	IF	EndOfCode > 0x7DC0
		error" Error out of range in EndOfCode "
	ENDIF
;
		ORG	0xF00000	
		#INCLUDE	<eeprom.asm>		;
;
;***********************************************************************
;
		END
;
;
