;
;********************************************************************
AdcSet0		EQU	0x00		;ADC off
AdcSet1		EQU	0x0F		;all digital I/O
AdcSet2		EQU	0x06		;left, Fosc/64
;
TxstaSet	EQU	B'00100110'	;8b,On,Asy,HS 
RcstaSet	EQU	B'10010000'	;On,8b,En,NoAddr.
BaudconSet	EQU	B'00000000'	;
SpbrgSet	EQU	(10-1)		;115200b/s
;
Tmr0Set		EQU	B'11000101'	;TMR0 on, 8 bit, TCY, 1:64
;
IntconSet	EQU	B'10100000'	;GIE=1, TMR0IE=1, TMR0IF=0
;
;RA0 - 			output							
;RA1 - 			output						
;RA2 - 			output                
;RA3 - 			output
;RA4 - 			output                                     
;RA5 - ComCTS		input
RA_Out		EQU	B'00000000'	;RA output data
RA_Dir		EQU	B'00100000'	;RA directions
;
;RB0 -  		output
;RB1 - 			output
;RB2 - 			output
;RB3 - 			output
;RB4 - 			output
;RB5 - 			input          
;RB6 - Debug		input
;RB7 - Debug		input
RB_Out		EQU	B'00000000'	;RB output data
RB_Dir		EQU	B'11100000'	;RB directions
;
;RC0 - 			output
;RC1 - 			output			
;RC2 - 			output
;RC3 - I2C sclk		input
;RC4 - I2C data		input
;RC5 - ComRTS		output
;RC6 - ComTxD		output
;RC7 - ComRxD		input
RC_Out		EQU	B'01100000'	;RC output data
RC_Dir		EQU	B'10011000'	;RC directions
;
;RD0 - sense0		input
;RD1 - sense1		input
;RD2 - sense2		input
;RD3 - sense3		input
;RD4 - scan0		inpit
;RD5 - scan1		input
;RD6 - scan2		input
;RD7 - scan3		input
RD_Out		EQU	B'11111111'	;RD output data
RD_Dir		EQU	B'11111111'	;RD directions
;
;RE0 - 			output
;RE1 - 			output
;RE2 - 			output
RE_Out		EQU	B'00000000'	;RE output data
RE_Dir		EQU	B'00000000'	;RE directions
;
;
#DEFINE	ComRxD		PORTC,7		;input
#DEFINE	ComTxD		PORTC,6		;output
#DEFINE	ComRTS		PORTC,5		;output
#DEFINE	ComCTS		PORTA,5		;input
;
#DEFINE	flag0		flags0,0
#DEFINE	flag1		flags0,1
#DEFINE	flag2		flags0,2
#DEFINE	flag3		flags0,3
#DEFINE	flag4		flags0,4
#DEFINE	flag5		flags0,5
#DEFINE	flag6		flags0,6
#DEFINE	flag7		flags0,7
#DEFINE	temp0_flag	flags1,0
#DEFINE	temp1_flag	flags1,1
#DEFINE	rtc_10ms_flag	flags1,2
#DEFINE	rtc_100ms_flag	flags1,3
#DEFINE	rtc_1s_flag	flags1,4
#DEFINE	scan_flag	flags2,5
#DEFINE	kbd_flag	flags2,6
;
;********************************************************************
c_24		EQU	0x1000000
c_16		EQU	0x10000
c_08		EQU	0x100
;********************************************************************			
c_scan_time	EQU	2		;N*10ms
CR		EQU	0x0D
#DEFINE	ESC	0x1B
;********************************************************************			
;
;
