;
;********************************************************************
;    Filename:	     V2.asm                
;    Date:           02/11/2012            
;    File Version:   12110200                 
;    Author(s):                
;    Company:        VSER                    
;********************************************************************
;    Files required: text.h, options.h, header.h, constants.h
;		     variables.h, macro.h 
;                    V2.asm, reset.asm, isrh.asm,isrl.asm
;                    init.asm, subroutines.asm		
;		     eeprom.asm
;********************************************************************
;    Notes:             
;    - processor:    PIC18F4520         
;    - quartz:       18.4320 MHz          
;********************************************************************
		#INCLUDE	<text.h>
		#INCLUDE	<options.h>
		#INCLUDE	<header.h>
		#INCLUDE	<constants.h>
		#INCLUDE	<variables.h>
		#INCLUDE	<macro.h>
;********************************************************************
;CODE
		ORG	StartUserCode
		#INCLUDE	<reset.asm>		;
;
		ORG	StartUserCode+0x0008
		goto	InterruptHigh			;
;
		ORG	StartUserCode+0x0018
		goto	InterruptLow			;
;
;***********************************************************************
;
		ORG	StartUserCode+0x002A
Main		
						;Inicijalizovati, u glavnom programu, FSR0 sa adresom buffer.
						;Inicijalizovati loop_counter
						;	sa vrednoscu c_buffer_length.
						;Obrisati WREG.
main_loop0	
						;Primenom programske petlje upisati u buffer sadrzaj WREG.
						;U svakom prolazu kroz petlju povecavati sadrzaj WREG za c_korak.
						;Broj prolaza brojati loop_counter-om.
						;
;
						;U file registar na adresi buffer_end
						;	upisati 0xAA.
;		
						;Inicijalizovati FSR0 sa adresom buffer.
main_loop1	
						;Primenom programske petlje obrisati buffer.
						;Za izlazak iz petlje koristiti
			 			;poredjenje FSR0 sa buffer_end.
						;
						;
			 			;
						;
;
						;U file registar na adresi buffer_end
						;	upisati 0x55.
;		
dead_loop	
		clrwdt				;Zaglaviti se u mrtvoj petlji
		bra	dead_loop		;
;MainEnd
;
;***********************************************************************
;
		#INCLUDE	<isrh.asm>		;
		#INCLUDE	<isrl.asm>		;
		#INCLUDE	<init.asm>		;
		#INCLUDE	<subroutines.asm>	;
;
EndOfCode	;0x7DC0 - 0x7DFF reserved for ICD2
	IF	EndOfCode > 0x7DC0
	 error" Error out of range in EndOfCode "
	ENDIF
;
		ORG	0xF00000	
		#INCLUDE	<eeprom.asm>		;
;
;********************************************************************
;
		END
;
;
