;
;********************************************************************
;    Filename:	     V3.asm                
;    Date:           09/11/2012            
;    File Version:   12110900                 
;    Author(s):                
;    Company:        VSERss                    
;********************************************************************
;    Files required: text.h, options.h, header.h, constants.h
;		     variables.h, macro.h 
;                    V3.asm, reset.asm, isrh.asm,isrl.asm
;                    init.asm, subroutines.asm		
;		     eeprom.asm
;********************************************************************
;    Notes:             
;    - processor:    PIC18F4520         
;    - quartz:       18.432000 MHz          
;********************************************************************
		#INCLUDE	<text.h>
		#INCLUDE	<options.h>
		#INCLUDE	<header.h>
		#INCLUDE	<constants.h>
		#INCLUDE	<macro.h>
;********************************************************************
;CODE
		ORG	StartUserCode
		#INCLUDE	<reset.asm>		;
;
		ORG	StartUserCode+0x0008
		goto	InterruptHigh			;
;
		ORG	StartUserCode+0x0018
		goto	InterruptLow			;
;
;***********************************************************************
;
		ORG	StartUserCode+0x002A
;
Main			
							;Inicijalizovati FSR0 sa adresom "buffer" 
;
							;Inicijalizovati table_counter sa vrednoscu (TableEnd-Table)/2 
							;
;
							;Inicijalizovati
							; PCLATU,
							; PCLATH i
							; table_pointer,
							; sa adresom "Table-2"
							;
;
main_loop0	
							;Ocitati podatak iz tabele
;
							;Prilikom kopiranja preskociti karaktere
							; 'e' i 'a'.
							;
							;
							;
;							;U svakom prolazu kroz petlju modifikovati podatke.
							;setovati b0 i b3
							;resetovati b2 i b4
							;invertovati b1, b5 i b6.
;
							;modifikovan podatak upisati u buffer
main_loop_no_copy		
							;Broj prolaza brojati table_counter-om.
							;
;		
main_dead_loop
		clrwdt					;zaglaviti se u mrtvoj petlji.
		bra	main_dead_loop			;
;
;MainEnd
;
;***********************************************************************
;
		#INCLUDE	<isrh.asm>		;
		#INCLUDE	<isrl.asm>		;
		#INCLUDE	<init.asm>		;
		#INCLUDE	<subroutines.asm>	;
		#INCLUDE	<variables.h>		;
;
EndOfCode	;0x7DC0 - 0x7DFF reserved for ICD2
	IF	EndOfCode > 0x7DC0
	 error" Error out of range in EndOfCode "
	ENDIF
;
		ORG	0xF00000	
		#INCLUDE	<eeprom.asm>		;
;
;********************************************************************
;
		END
;
;
