;
;
;SUBROUTINES
;
Delay3						;delay 4*(W+1)TCY+2TCY
		nop				
Delay2						;delay 4*(W+1)TCY+1TCY
		nop				
Delay1						;delay 4*(W+1)TCY
		nop				
Delay0						;delay 4*(W+1)TCY-1TCY
		clrwdt
		addlw	-1			
		bnz	Delay0
		retlw	0x00			;W=0, Z=1, C=1
;Delay_end	
;
;
DelayM
		btfsc	delay_modulation,0
		bra	$+2
		rlncf	delay_modulation
		return
;DelayMEnd
;
;
;Wait
Wait1s
c_wait	SET	10000
		movlw	high	(c_16-c_wait)
		movwf	wait_counter1
		movlw	low	(c_16-c_wait)
		movwf	wait_counter0
		bra	Wait
;
Wait100ms
c_wait	SET	1000
		movlw	high	(c_16-c_wait)
		movwf	wait_counter1
		movlw	low	(c_16-c_wait)
		movwf	wait_counter0
		bra	Wait
;
Wait10ms
c_wait	SET	100
		movlw	high	(c_16-c_wait)
		movwf	wait_counter1
		movlw	low	(c_16-c_wait)
		movwf	wait_counter0
		bra	Wait
;
Wait1ms
c_wait	SET	10
		movlw	high	(c_16-c_wait)
		movwf	wait_counter1
		movlw	low	(c_16-c_wait)
		movwf	wait_counter0
		bra	Wait
;
Wait
c_wait_loop	SET	111
		movlw	B'11101110'
		movwf	delay_modulation
		movlw	(c_wait_loop-3)
;
wait_loop						;100us
		rcall	DelayM
		rcall	Delay1
		movlw	c_wait_loop
		infsnz	wait_counter0
		incfsz	wait_counter1
		bra	wait_loop
;
		return
;WaitEnd		
;
;
Add24		;(op12,op11,op10)+(op02,op01,op00)=(op12,op11,op10)
		movf	op00,W
		addwf	op10
		movf	op01,W
		addwfc	op11
		movf	op02,W
		addwfc	op12
;
		return
;Add24End
;
;
Sub24		;(op12,op11,op10)-(op02,op01,op00)=(op12,op11,op10)
		movf	op00,W
		subwf	op10
		movf	op01,W
		subwfb	op11
		movf	op02,W
		subwfb	op12
;
		return
;Sub24End
;
;
Rnd16
		movf	rnd0,W			;da li je <rnd1,rnd0>=0x0000
		iorwf	rnd1,W
		btfsc	STATUS,Z
		incf	rnd0
;
		bcf	STATUS,C
;
		btfsc	rnd1,7
		btg	STATUS,C
;
		btfsc	rnd1,6
		btg	STATUS,C
;
		btfsc	rnd1,4
		btg	STATUS,C
;		
		btfsc	rnd0,3
		btg	STATUS,C
;
		rlcf	rnd0
		rlcf	rnd1
;
		return
;Rnd16End
;
;
;Podatak u HEX formatu na koji pokazuje FSR0 se konvertuje
; u tri bajta BCD koda na koja pokazuje FSR1
Hex2Bcd		
		bsf	blank_flag
;
		movff	POSTINC0,op10
;
		movlw	100			;100
		movwf	op00
		rcall	Hex2BcdLoop
;
		movlw	10			;10
		movwf	op00
		rcall	Hex2BcdLoop
;
		bcf	blank_flag
;
		movlw	1			;1
		movwf	op00
		rcall	Hex2BcdLoop
;
		return
;Hex2BcdEnd		
;
Hex2BcdLoop
		clrf	INDF1
hex2bcd_loop
		movf	op00,W
		subwf	op10
		bnc	hex2bcd_loop_out	;da li je doslo do prekoracenja
;
		incf	INDF1
		bcf	blank_flag
		bra	hex2bcd_loop
;
hex2bcd_loop_out
		movf	op00,W
		addwf	op10
;
		movlw	c_blenk			;blenkiranje vodecih nula
		btfsc	blank_flag
		movwf	INDF1
;
		movf	POSTINC1		;inkrementiranje FSR1
;
		return
;Hex2BcdLoopEnd
;
;
Table		;1 - segment upaljen, 0 - segment ugasen
;	  		  0gfedcba    0gfedcba    0gfedcba    0gfedcba
		DB	B'00111111',B'00000110',B'01011011',B'01001111'		;0,1,2,3
		DB	B'01100110',B'01101101',B'01111101',B'00000111'		;4,5,6,7
		DB	B'01111111',B'01100111',B'00000000'			;8,9,blank
;TableEnd
;
;
Sort0
sort0_loop0            
                movlw   (buffer0_end-buffer0-1)
                movwf   loop_counter0
                lfsr    FSR0,(buffer0+0)
                lfsr    FSR1,(buffer0+1)
                bsf     done_flag
;
sort0_loop1              
                movf    INDF0,W
                cpfslt  INDF1
                ;cpfsgt  INDF1
                bra     sort0_loop1_nop
;                
                movff   INDF1,INDF0
                movwf   INDF1
                bcf     done_flag
;
sort0_loop1_nop
		movf	POSTINC0
		movf	POSTINC1
                decfsz  loop_counter0
                bra     sort0_loop1
;
                btfss   done_flag
                bra     sort0_loop0
;
                lfsr    FSR0,(buffer0+(buffer0_end-buffer0)/2)
                movf    INDF0,W
;
                return

;Sort0End
;
;
Sort1
                movlw   (buffer0_end-buffer0-1)
                movwf   loop_counter0
                movwf   loop_counter1
                lfsr    FSR0,(buffer0+0)
                lfsr    FSR1,(buffer0+1)
sort1_loop0
                movf    INDF0,W
                ;cpfslt  INDF1
                cpfsgt  INDF1
                bra     sort1_loop0_nop
;
                movff   INDF1,INDF0
                movwf   INDF1   
;
sort1_loop0_nop
		movf	POSTINC1
                decfsz	loop_counter0
                bra     sort1_loop0
;
		dcfsnz	loop_counter1
		bra	sort1_loop0_out
;
                movf    POSTINC0
                movff   FSR0L,FSR1L
                movff   FSR0H,FSR1H
                movf	POSTINC1
                movff	loop_counter1,loop_counter0
		bra	sort1_loop0
;
sort1_loop0_out
                lfsr    FSR0,(buffer0+(buffer0_end-buffer0)/2)
                movf    INDF0,W
;
                return
;Sort1End                               
;
;
;Konverzija hex -> ascii
;ulaz:  W (hex format u donjem niblu)
;izlaz: W (ASCII kod)
;koristi se: W, STATUS
;PM=6, DM=0, TCY=7
Hex2Ascii
                andlw   0x0F		;zastita u slucaju pogresnog ulaza            
                addlw   -0x0A           
                bnc	$+4		;da li je 0-9 ili A-F
                addlw   0x07            
                addlw   0x3A            
;
                return                  
;Hex2AsciiEnd
;
;
;Konverzija ascii -> hex
;ulaz:  W (mala ili velika slova)
;izlaz: W (donji nibl, gornji nibl je 0000)
;koristi se: W, STATUS
;PM=7, DM=0, TCY=7
Asc2hex 
	        andlw   0xDF            ;mala slova se prevode u velika
                btfsc   WREG,6          ;da li je 0-9 ili A-F
                addlw   -0x07           ;
                addlw   -0x30           ;
                andlw   0x0F            ;zastita u slucaju pogresnog ulaza
;
		return                  ;
;Asc2hex_end    
;
;
;Slanje podataka po serijskoj liniji
SendCharacter
		btfss	PIR1,TXIF
		bra	$-2
		movwf	TXREG
		return
;SendCharacterEnd
;
;
							
