;
;********************************************************************
;    Filename:	     V8.asm                
;    Date:           14/12/2012            
;    File Version:   12121400                 
;    Author(s):                
;    Company:        VSERss                    
;********************************************************************
;    Files required: text.h, options.h, header.h, constants.h
;		     variables.h, macro.h 
;                    V8.asm, reset.asm, isrh.asm,isrl.asm
;                    init.asm, subroutines.asm		
;		     eeprom.asm
;********************************************************************
;    Notes:             
;    - processor:    PIC18F4520         
;    - quartz:       18.432000 MHz          
;********************************************************************
		#INCLUDE	<text.h>
		#INCLUDE	<options.h>
		#INCLUDE	<header.h>
		#INCLUDE	<constants.h>
		#INCLUDE	<variables.h>
		#INCLUDE	<macro.h>
;********************************************************************
;CODE
		ORG	StartUserCode
		#INCLUDE	<reset.asm>		;
;
		ORG	StartUserCode+0x0008
		goto	InterruptHigh			;
;
		ORG	StartUserCode+0x0018
		goto	InterruptLow			;
;
;********************************************************************
;
		ORG	StartUserCode+0x002A
;
Main
		clrf	TMR0L
		movlw	IntconSet
		movwf	INTCON
;
main_scan_loop0
main_wait4scan_flag
		btfss	scan_flag
		bra	main_wait4scan_flag
		bcf	scan_flag
;				
		rcall	KbdScan
		btfss	kbd_flag
		bra	main_scan_loop0
;
		movf	kbd_buffer,W
		rcall	SendCharacter
		bra	main_scan_loop0
;
;MainEnd
;
;********************************************************************
;
		#INCLUDE	<isrh.asm>		;
		#INCLUDE	<isrl.asm>		;
		#INCLUDE	<init.asm>		;
		#INCLUDE	<subroutines.asm>	;
;
EndOfCode	;0x7DC0 - 0x7DFF reserved for ICD2
	IF	EndOfCode > 0x7DC0
		error" Error out of range in EndOfCode "
	ENDIF
;
		ORG	0xF00000	
		#INCLUDE	<eeprom.asm>		;
;
;********************************************************************
;
		END
;
;
