;
InterruptHigh						;interrupt vector
;
SaveH							;save WREG, STATUS, BSR, FSR0
		movff	WREG,wreg_temp_h		
		movff	STATUS,status_temp_h
		movff	BSR,bsr_temp_h
		movff	FSR0L,fsr0l_temp_h
		movff	FSR0H,fsr0h_temp_h
		SetBank1				;Bank 1
;SaveHEnd						
;
;
DetectEventsH
		btfss	INTCON,T0IE
		bra	detect_events_h_next1
		btfsc	INTCON,T0IF
		bra	RealTimeClock
;
detect_events_h_next1
;
			bra	RestoreH		;false interrupt
;DetectEventsHEnd
;
;
RealTimeClock	
		bcf	INTCON,T0IF
		movlw	64
		addwf	rtc_prescaler
		movlw	180
		cpfslt	rtc_prescaler
		bra	real_time_clock_10ms
			bra	RestoreH
;
real_time_clock_10ms			
		subwf	rtc_prescaler
;
		decfsz	scan_timer
		bra	scan_timer_non_zero
scan_timer_zero
		movlw	c_scan_time
		movwf	scan_timer
		bsf	scan_flag		
scan_timer_non_zero
;
		decfsz	rtc_10ms
			bra	RestoreH
;
real_time_clock_100ms
		bsf	rtc_100ms_flag					
;
		movlw	10
		movwf	rtc_10ms
;
		decfsz	rtc_100ms
			bra	RestoreH
;
real_time_clock_1s
		bsf	rtc_1s_flag					
;
		movlw	10
		movwf	rtc_100ms
			bra	RestoreH
;
;RealTimeClockEnd	
;
;
RestoreH					;restore WREG, STATUS, BSR, FSR0
		movff	fsr0l_temp_h,FSR0L
		movff	fsr0h_temp_h,FSR0H
		movff	wreg_temp_h,WREG
		movff	bsr_temp_h,BSR
		movff	status_temp_h,STATUS
;RestoreHEnd
;		
		retfie				;enable GIE
;InterruptHighEnd	
;
;
